﻿package ru.k0t0vich.fluent.parsers 
{
	import ru.k0t0vich.fluent.FluentList;
	/**
	 * ...
	 * @author k0t0vich
	 */
	public class CommandParser
	{
		
		public static function parse(fluentList:FluentList,array:Array):FluentList
		{
			var retList:FluentList = fluentList;
			var command:String = array[0];
			//trace("command : " + command);
				switch(command)
				{
					case FluentCommand.CALL:
							var args:Array = array.splice(2, array.length - 2);
							//trace("args : " + args);
							retList = retList.call(array[1], args);
					break;	
					case FluentCommand.WHERE:
						var field:String = array[1];
						var condition:String = array[2];
						var value:* = array[3];
						retList =retList.where(field,condition, int(value));						
					break;
					case FluentCommand.SORT:
					case FluentCommand.SORTON:
						var options:int = 0;
						switch(array[2])
						{
							case SortAttributes.NUMERIC:
								options = Array.NUMERIC;
							break;
							//TODO: прописать остальные типы сортировки
							default:
								options = 0;
							break;
						}
						retList = retList.sortOn(array[1],options);
					break;
					case FluentCommand.OR:
					case FluentCommand.JOIN:
						retList = retList.or();
					break;
					case FluentCommand.GROUP:
						retList = retList.group();
					break;
					default:
						throw(new Error("'" + command + "' is illegal command of FluentScript"));
					break;
				}
			return retList;	
		}
	}

}